
Ruby - Bug #5317

rubyのヘッダファイルを使った拡張を行う際にoff_tの宣言回避をする事が出来ない。

09/13/2011 09:47 PM - mattn (Yasuhiro Matsumoto)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

ruby -v: - Backport:  

Description

以前、vimのif_ruby(ruby拡張)の修正を担当した時、mingw32でのuid_tの宣言とrubyに同梱されているwin32.hでの宣言に差異があり、リンクされた物がクラッシュするというバグに遭遇しま

した。

vimでrubyに関連するのはif_ruby.cであり、そのファイルのみがruby.hをincludeしているのですが(他のファイルもruby.hをincludeしろというのは無しです)、別のファイルはmingw32の

宣言である

sys/types.h:

typedef long _off_t;

と

ruby-1.9.1/ruby/win32.h:

#define off_t __int64

https://github.com/ruby/ruby/blob/trunk/include/ruby/win32.h

が競合してしまい、構造体内にoff_t型のメンバを持つ２つのオブジェクトファイル通しでメンバ参照すると落ちるという物でした。

win32.hの方は、SIZEOF_OFF_Tが宣言されていれば#defineを回避出来ますが、このSIZEOF_OFF_Tはconfigureで吐かれるconfig.hに出力されてしまっている事から、ruby.

h → ruby/ruby.h → ruby/config.h と読み込まれて(win32の場合)、結果としてSIZEOF_OFF_Tは変更出来ない事になります。

vimの場合は、LoadLibraryとGetProcAddressを使ったダイナミックローディングを使っていますが、出来れば宣言くらいは横着してヘッダファイルが使いたいので、出来ればoff_tの宣言回避が出

来ない物かと思っています。

Associated revisions

Revision e2ccb316b437104cd1734c378970d34f5305966d - 09/08/2022 02:01 PM - nobu (Nobuyoshi Nakada)

[Bug #5317] Use rb_off_t instead of off_t

Get rid of the conflict with system-provided small off_t.

Revision e2ccb316b437104cd1734c378970d34f5305966d - 09/08/2022 02:01 PM - nobu (Nobuyoshi Nakada)

[Bug #5317] Use rb_off_t instead of off_t

Get rid of the conflict with system-provided small off_t.

Revision e2ccb316 - 09/08/2022 02:01 PM - nobu (Nobuyoshi Nakada)

[Bug #5317] Use rb_off_t instead of off_t

Get rid of the conflict with system-provided small off_t.

History

#1 - 09/13/2011 09:51 PM - mattn (Yasuhiro Matsumoto)

ぜんぜんuid_tじゃないですねw off_tでした！

以下、s/uid_t/off_t/g で置き換えて下さい。

#2 - 09/13/2011 10:24 PM - nobu (Nobuyoshi Nakada)

- Subject changed from rubyのヘッダファイルを使った拡張を行う際にuid_tの宣言回避をする事が出来ない。 to rubyのヘッダファイルを使った拡張を行う際にoff_tの宣言回避をする事が出来ない。

#3 - 09/13/2011 10:51 PM - nobu (Nobuyoshi Nakada)
https://github.com/ruby/ruby/blob/trunk/include/ruby/win32.h


Yasuhiro Matsumoto wrote:

sys/types.h:

typedef long _off_t;

と

ruby-1.9.1/ruby/win32.h:

#define off_t __int64

https://github.com/ruby/ruby/blob/trunk/include/ruby/win32.h

が競合してしまい、構造体内にoff_t型のメンバを持つ２つのオブジェクトファイル通しでメンバ参照すると落ちるという物でした。

 ruby.hのあとで #undef off_t では回避できませんか。

#4 - 09/14/2011 12:58 AM - mattn (Yasuhiro Matsumoto)

vimのpatchとしてはそうしました。

https://groups.google.com/d/topic/vim_dev/VM_AgsF1_K4/discussion

ただ、あまりお作法が良いとは思えませんでした。

出来ればどのプロジェクトでも

#undef off_t

しなくても良い形がのぞましいと思ってます的な意味でfeature requestです。:)

#5 - 09/14/2011 06:25 AM - naruse (Yui NARUSE)

システムに _off_t があったら、__int64 ではなく _off_t を使うようにすればいいんですかね。

いや、_off64_t か?

#6 - 09/14/2011 09:33 AM - mattn (Yasuhiro Matsumoto)

システムに _off_t があったら、__int64 ではなく _off_t を使うようにすればいいんですかね。

いや、_off64_t か?

 そうですね。

もしくはconfig.hのSIZEOF_OFF_T宣言を無効化出来るとか。

#ifndef SIZEOF_OFF_T

#define SIZEOF_OFF_T 8

#endif

まぁoff_tに限った話でもなさそうですが。

#7 - 03/27/2012 03:06 AM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

まあこれは何かしら対処すべきじゃないですかね。

#define off_t を入れたのはなかださんっぽい (r10720) ので、

なかださんお願いします。

--

Yusuke Endoh mame@tsg.ne.jp

#8 - 11/24/2012 01:08 PM - mame (Yusuke Endoh)

- Tracker changed from Feature to Bug

これはバグ扱いでいいですかね。早くなんとかしてくれると嬉しいです。

もしもう直ってたら閉じてください。

--

Yusuke Endoh mame@tsg.ne.jp
#9 - 02/18/2013 09:21 PM - mame (Yusuke Endoh)

- Target version changed from 2.0.0 to 2.1.0

- ruby -v set to -

残念ながら何ともしてもらえなかったですかね。まあ回避策あるので先送りにします。

--

Yusuke Endoh mame@tsg.ne.jp

#10 - 01/30/2014 06:16 AM - hsbt (Hiroshi SHIBATA)

- Target version changed from 2.1.0 to 2.2.0

#11 - 01/05/2018 09:00 PM - naruse (Yui NARUSE)

- Target version deleted (2.2.0)

#12 - 09/08/2022 02:01 PM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

Applied in changeset git|e2ccb316b437104cd1734c378970d34f5305966d.

[Bug #5317] Use rb_off_t instead of off_t

Get rid of the conflict with system-provided small off_t.
